=== debian/changelog ===
r-base (1.4.1.cvs20020414-2) unstable; urgency=low

  * debian/control: Added virtual fortran77-compiler, c-compiler to the
    list of alternative compilers that r-base-dev Depends: on

 --

r-base (1.4.1.cvs20020414-1) unstable; urgency=low

  * Upgraded to new release candidate 2002-04-14 of R 1.5.0

 -- Dirk Eddelbuettel <edd@debian.org>  Sat, 13 Apr 2002 20:48:59 -0500

r-base (1.4.1.cvs20020407-1) unstable; urgency=low

  * Upgraded to new release candidate 2002-04-07 of R 1.5.0

 -- Dirk Eddelbuettel <edd@debian.org>  Sun,  7 Apr 2002 07:59:43 -0500

r-base (1.4.1.cvs20020331-1) unstable; urgency=low

  * Upgraded to new release candidate 2002-03-23 of R 1.5.0

  * debian/control: Build-Depends on texinfo (>= 4.1-2) to ensure that 
    we will not be bitten by the epsf.tex bug 
  
 -- Dirk Eddelbuettel <edd@debian.org>  Sun, 31 Mar 2002 08:55:08 -0600

r-base (1.4.1.cvs20020323-1) unstable; urgency=low

  * Upgraded to new release candidate 2002-03-23 of R 1.5.0

  * debian/control: New packages r-base-core, r-base-html, r-base-latex 
    and r-doc-info have been split from the old r-base package which now 
    Depends: on these, but can also be removed -- this adds some extra
    flexibility and can save over eight megabytes of installed files.
  * debian/control: Replaces: r-base (<= 1.4.1-1) for the new packages

  * debian/rules: Fortan compiler selection adapted to new upstream configure
  * debian/control: r-base Suggests: r-base-dev instead of gcc
  * debian/copyright: Updated and included current COPYRIGHTS file ...
  * debian/rules: ... and therefore do not install COPYRIGHTS separately
  * debian/control: Added Build-Depends on texi2html (split from tetex-bin)
  
 -- Dirk Eddelbuettel <edd@debian.org>  Sat, 23 Mar 2002 11:17:48 -0600

r-base (1.4.1-1) unstable; urgency=low

  * Upgraded to new upstream release 1.4.1

 -- Dirk Eddelbuettel <edd@debian.org>  Wed, 30 Jan 2002 18:50:34 -0600

r-base (1.4.0.cvs20020124-1) unstable; urgency=low

  * Upgraded to the R-patched_2002-01-24 release candidate for 1.4.1

 -- Dirk Eddelbuettel <edd@debian.org>  Thu, 24 Jan 2002 19:38:34 -0600

r-base (1.4.0-1) unstable; urgency=low

  * Upgraded to new upstream release 1.4.0
  * debian/control: Add lib{zvt,gtkxmhtml}-dev to Build-Depends [thanks, Doug]
  * debian/control: Fixed hppa Build-Depends [thanks, Matthew Wilcox]
  * debian/rules: Minor cleanup regarding configuration options
  * debian/control: Changed Priority: from extra to optional
  * debian/control: Corrected r-doc-html Description [thanks, Doug Bates]
  * debian/control: Spelling corrections (Closes: #125300)
  
 -- Dirk Eddelbuettel <edd@debian.org>  Wed, 19 Dec 2001 18:47:46 -0600

r-base (1.3.1-6) unstable; urgency=low

  * debian/rules: Also apply s/-lg2c/-lg2c-pic/ on etc/Makeconf
  * debian/control: Revert to Arch: all for doc packages, no Depends r-base
  * debian/control: r-base-dev Depends remodelled on r-base Build-Depends

 -- Dirk Eddelbuettel <edd@debian.org>  Mon,  3 Dec 2001 21:58:40 -0600

r-base (1.3.1-5) unstable; urgency=low

  * debian/rules: Unset CPPFLAGS, LIBS before calling configure to not
    leave traces of /usr/local. Thanks, Kurt Hornik (Closes: #71917)
  * debian/rules: More s/-lg2c/-lg2c-pic/ substitution in src/library/
  * debian/control: Added new package r-mathlib (Closes: #119701)
  * debian/control: Added new package r-doc-html (R manuals in html format)
  * debian/rules: Added suitable rules for r-mathlib and r-doc-html
  * debian/rules: Rewritten/cleaned for DH_COMPAT=3
  
 -- Dirk Eddelbuettel <edd@debian.org>  Fri, 16 Nov 2001 20:43:24 -0600

r-base (1.3.1-4) unstable; urgency=low

  * debian/control: Corrected maintainer email
  * debian/rules: Do not run 'make check' on arm as it stumbles over the
    Bessel example; this known misfeature has long been reported upstream
  * debian/README.Atlas: Updated to reflect autoMAGIC loading of Atlas lib
    with ldconfig from libc6_2.2.4-5 or later -- thanks, Ben Collins!
  
 -- Dirk Eddelbuettel <edd@debian.org>  Sun, 11 Nov 2001 11:19:10 -0600

r-base (1.3.1-3) unstable; urgency=low

  * New maintainer
  * debian/rules: Substitute -lg2c-pic for -lg2c in Makeconf [Thanks, Jeff!]
  * debian/control: Following advice from the Release Manager, let r-doc-pdf
    and r-base-dev be Arch: any as they Depends: on r-base itself 
  * debian/rules: configure with tkConfig.sh,tclConfig.sh for 8.3 support
  * debian/control: Build-Depends on tcl8.3-dev and tk8.3-dev
  * debian/rules: Let ia64 use gcc-3.0, g77-3.0, g++-3.0
  * debian/control: Build-Depends adjusted accordingly

 -- Dirk Eddelbuettel <edd@debian.org>  Fri,  9 Nov 2001 20:17:43 -0600

r-base (1.3.1-2) unstable; urgency=low

  * Non-maintainer upload, coordinated with the maintainer
  * Fixed local teTeX issue so that pdf manuals are built (Closes: #112184)
  * debian/*.links: link r-doc-pdf, r-gnome, r-base-dev doc dir to r-base
  * debian/*.preinst: rm doc dir for r-doc-pdf, r-gnome, r-base-dev 
  * debian/control: r-base-dev and r-doc-pdf now depend on r-base
  
 -- Dirk Eddelbuettel <edd@debian.org>  Fri, 14 Sep 2001 21:53:24 -0500

r-base (1.3.1-1) unstable; urgency=low

  * Non-maintainer upload, coordinated with the maintainer
  * Upgraded to new upstream release 1.3.1
  * src/scripts/R.sh.in: Modified to detect libs from /etc/ld.so.conf so
    that Atlas is now used automatically when installed, providing very
    significant performance gains. Thanks for Kurt Hornik for the sed magic. 
  * debian/control: Build-Depends for f2c on m68k, g77 everywhere else
  * debian/rules: Use f2c on m68k, g77 everywhere else
  * debian/rules: Compile with -O on m68k, -O2 everywhere else. Thanks 
    to Christian Steigies for countless m68k tests and compilations 
  * debian/r-base.lintian: Added Lintian excpeptions clauses:
    -- for files not under md5sum creation as their content changes
    -- for spurious 'extra license' on license() command documentation

